
<script>

/*
	{
		   "scene #": "1",
		   
			#
			#  The play # of the player that is making the proposal
			#
			"flavor move #": "1",
			
			"move": "send escrow",
  
			"return after scene": "1001",
			"amount": "1,0000,0000",
			"fee": "1000",
			
			"sender": "ECC_448_2:304...a80",
			"receiver": "ECC_448_2:304...480"
		}

*/

/*
	json-tree-view-vue3
	
	https://github.com/cloydlau/json-editor-vue
	
	https://www.npmjs.com/package/pretty-print-json
*/
import 'vanilla-jsoneditor/themes/jse-theme-dark.css'
import JsonEditorVue from 'json-editor-vue'

import { lap } from '@/fleet/lap'

import { furnish_string } from 'procedures/furnish/string'

import { send_escrow } from '@/grid/moves/send_escrow'

export default {
	inject: ['vibes_store'],
	
	components: {
		JsonEditorVue
	},
	
	props: {
		name: ""
	},
	
	data () {
		return {
			vibe: '',
			
			fields_inputs: {
				story: {
					sender: '',
					receiver: '',
					amount: '',
					fee: '',
					
					"scene #": '',
					"vibe move # of scene": ''
				},
				performance: ''
			},
			
			proceeds_fields: {},
			
			styles: {
				textarea: {
					color: 'white',
					
					boxSizing: 'border-box',
					padding: '8px',
					border: '2px solid white',
					borderRadius: '4px',
					
					width: '100%',
					
					background: "transparent"
				}
			}
		}
	},
	
	watch: {
		'fields_inputs.story': {
			deep: true,
			async handler () {
				console.log ("changed")
				
				const proceeds = await this.vibes_store.moves.perform ({
					story: JSON.stringify (this.fields_inputs)
				})
				
				console.log ({ proceeds })
				
				if (proceeds.status === "pass") { 
					this.fields_inputs.performance = proceeds.note.performance;
				}
			}
		},
		
		name () {
			this.fields_inputs = {}
			this.proceeds_fields = {}
		}
	},
	
	created () {
		this.vibes_store_monitor = this.vibes_store.monitor (({ inaugural, field }) => {
			const warehouse = this.vibes_store.warehouse ()

			console.log ('monitor function', { inaugural, field, warehouse })
			
			try {
				this.vibe = warehouse.vibe;
				
				this.fields_inputs.story.sender = warehouse.vibe.flavor;
			}
			catch (exception) {
				
			}
		})
	},
	beforeUnmount () {
		this.vibes_store_monitor.stop ()
	},
	
	methods: {
		async move () {
			const proceeds = await lap ({
				envelope: {
					name: "move: send escrow",
					fields: this.fields_inputs
				}
			});
			if (proceeds.status !== "pass") { 
				const note = furnish_string (proceeds, [ 'note' ], 'A failure occurred without details.')
				this.$vaToast.init ({ message: note, color: 'danger' })
				return;
			}
			
			const note = furnish_string (proceeds, [ 'note' ], 'A pass occurred without details.')
			this.$vaToast.init ({ message: note, color: 'success' })
			
			this.proceeds_fields = proceeds.fields;
		}
	}
}

</script>



<template>
	<div>
		<h1>{{ name }}</h1>
		
		<div
			:style="{
				padding: '20px',
				
				display: 'flex',
				justifyContent: 'space-between'
			}"
		>
			<VaButton
				@click="move"
				color="#000"
				textColor="#FFF"
			>perform</VaButton>
			
			<div :style="{ width: '20px', display: 'inline-block' }" />
		
			<VaButton
				@click="move"
				color="#000"
				textColor="#FFF"
			>propose</VaButton>
		</div>
	
		<div
			:style="{
				border: '2px solid white',
				padding: '10px'
			}"
		>
			<h2
				:style="{
					textAlign: 'center',
					fontSize: '1.5em'
				}"
			>out slip</h2>
		
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>sender</h4>
				<textarea
					v-model="fields_inputs.story.sender"
					:style="styles.textarea"
				/>
			</div>
			
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>receiver</h4>
				<textarea
					v-model="fields_inputs.story.receiver"
					:style="styles.textarea"
				/>
			</div>
			
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>amount</h4>
				<textarea
					v-model="fields_inputs.story.amount"
					:style="styles.textarea"
				/>
			</div>
			
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>fee</h4>
				<textarea
					v-model="fields_inputs.story.fee"
					:style="styles.textarea"
				/>
			</div>
		
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>scene #</h4>
				<textarea
					v-model="fields_inputs.story ['scene #']"
					:style="styles.textarea"
				/>
			</div>
			
			<div
				:style="{
					padding: '10px 0'
				}"
			>
				<h4>vibe move # of scene</h4>
				<textarea
					v-model="fields_inputs.story ['vibe move # of scene']"
					:style="styles.textarea"
				/>
			</div>
		
			<div
				:style="{
					color: 'white',
					
					background: 'linear-gradient(45deg, #8000805c, #513b4f, #77281645, #97975400)',
					border: '2px solid #9b3f9163',
					
					
					padding: '.1in',
					
					borderRadius: '10px',
					
					marginTop: '10px'
				}"		
			>
				<h2>fields</h2>
				<JsonEditorVue
					class="jse-theme-dark"
					v-model="fields_inputs"
				/>
			</div>
		</div>
	
		<div
			:style="{
				color: 'white',
				
				background: 'linear-gradient(45deg, #8000805c, #513b4f, #77281645, #97975400)',
				border: '2px solid #9b3f9163',
				
				
				padding: '.1in',
				
				borderRadius: '10px',
				
				marginTop: '10px'
			}"		
		>
			<JsonEditorVue
				class="jse-theme-dark"
				v-model="proceeds_fields"
			/>
		</div>
	
	</div>
</template>


